Foreman - Bug #14239

Creating a host via API fails with cryptic error when no primary interface is set explicitly
03/16/2016 12:51 PM - Ivan Necas

Status: Closed
Priority: Normal
Assignee: Tom Caspy
Category: Compute resources
Target version: 1.11.1
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3339
Description

when running

bundle exec bin/hammer host create --hostgroup=abcde —--compute-resource='abcde ovirt' —--name ineca
s—test—-1 —--location Default_Location \
—-—organization Default_Organizationl —--interface='compute_name=

eth0, compute_network=d3e5f222-1lece-4d77-bcl8-98b0937e72bf"
which causes this params to be sent to the API host controller:

{"host"=>{"name"=>"inecas-test-1", "location_id"=>2, "organization_id"=>1, "compute_resource_id"=>
3, "hostgroup_id"=>3, "build"=>true, "enabled"=>true, "managed"=>true, "compute_attributes"=>{"vol
umes_attributes"=>{}}, "overwrite"=>true, "host_parameters_attributes"=>{}, "interfaces_attributes
"=>[{"compute_attributes"=>{"name"=>"ethO0", "network"=>"d3e5f222-1lece-4d77-bcl8-98b0937e72bf"}}1},
"apiv"=>"v2"}

Ends up with error “Failed to create a compute abcde ovirt (oVirt) instance inecas-test-1.inecas.ovirt.test: Network not found in
cluster’

After debugging, it turns out the host is created with two interfaces, one corresponding to the params from the Ul, while another one
is build
by default https://github.com/theforeman/foreman/blob/1.11.0-RC2/app/models/host/base.rb#l.104

A workaround is to set “primary=true” as interface like this:

bundle exec bin/hammer host create --hostgroup=abcde —--compute-resource='abcde ovirt' --name ineca
s—test-1 —--location Default_Location \
—-organization Default_Organizationl --interface='compute_name=

eth0, compute_network=d3e5f222-1ece-4d77-bcl8-98b0937e72bf, primary=true'’
Expected result:

When no primary interface is set, the first one is considered as the one (consistent with the Ul)

Related issues:

Related to Foreman - Bug #14264: Getting 500 when creating host through API a... Closed 03/18/2016
Related to Hammer CLI - Bug #13927: Specifying provision and primary flags sh... Closed 02/27/2016
Has duplicate Foreman - Bug #13982: API description for creating hosts incorr... Duplicate 03/01/2016

Associated revisions

Revision 38d9333f - 03/18/2016 05:15 AM - Tom Caspy

fixes #14239 - when creating host from API, set first interface as primary if none set

Revision e83f4d7f - 04/18/2016 01:45 PM - Tom Caspy
https://github.com/theforeman/foreman/blob/1.11.0-RC2/app/models/host/base.rb#L104

fixes #14239 - when creating host from API, set first interface as primary if none set

(cherry picked from commit 38d9333f8e82e45fc6771ea7740e6ea625b97d3f)

History

#1 - 03/16/2016 12:53 PM - lvan Necas

- Description updated

#2 - 03/17/2016 10:02 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Tom Caspy

- Pull request https://github.com/theforeman/foreman/pull/3339 added

#3 - 03/18/2016 05:18 AM - Dominic Cleal

- Has duplicate Bug #13982: API description for creating hosts incorrectly lists "interfaces_attributes™s "primary" as optional added

#4 - 03/18/2016 06:02 AM - Tom Caspy
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 38d9333{8e82e45fc6771ea7740e6ea625b97d3f.

#5 - 03/18/2016 06:44 AM - Dominic Cleal

- translation missing: en.field_release set to 141

#6 - 03/18/2016 07:50 AM - Dominic Cleal
- Related to Bug #14264: Getting 500 when creating host through API and not specifying any interface attributes added

#7 - 03/18/2016 10:15 AM - Dominic Cleal
- Related to Bug #13927: Specifying provision and primary flags should not be mandatory added
